#Agent.py
from Tools import *
from turtle import *

register_shape("school1/pupilNero.gif")
register_shape("school1/pupilVerde.gif")
register_shape("school1/pupilRosso.gif")
register_shape("school1/pupilGiallo.gif")
register_shape("school1/pupilSpecial.gif")
register_shape("desk",((5,-15),(15,-15),(15,15),(5,15)))

class Agent(Turtle):
    def __init__(self, number,myWorldState,
                 xPos, yPos, lX =-20,rX=19, lY=-20, rY=19, agType=""):
        Turtle.__init__(self)
        # nb lX, rX, lY, rY are defined in ModelSwarm.py
        
        # the environment
        self.agOperatingSets=[]
        self.number = number
        self.lX = lX
        self.rX = rX
        self.lY = lY
        self.rY = rY
        self.myWorldState = myWorldState
        self.agType=agType
        # the agent
        self.xPos = xPos
        self.xPos0=xPos
        self.yPos = yPos
        self.yPos0=yPos
        self.deltaAtt=0
        print "agent", self.agType, "#", self.number, \
     	      "has been created at", self.xPos, ",", self.yPos

        # turtle behavior
        self.speed(0)
        self.penup()
        self.color("black")
        self.setx(self.xPos*1)
        self.sety(self.yPos*1)

        # attention accounting
        self.attention=0
        self.tickAttention=0
        self.nMethodsAttention=0

    def setColor(self,color):
        self.color(color)
        if color=="black"  : self.shape("school1/pupilNero.gif")
        if color=="green"  : self.shape("school1/pupilVerde.gif")
        if color=="red"    : self.shape("school1/pupilRosso.gif")
        if color=="yellow" : self.shape("school1/pupilGiallo.gif")
        if color=="violet" : self.shape("school1/pupilSpecial.gif")
        
        if color=="brown"  : self.shape("desk")

    # add an operating  set
    def setAnOperatingSet(self,aSet):
        self.agOperatingSets.append(aSet)

    # get operating set list
    def getOperatingSetList(self):
        return self.agOperatingSets

    # reset values
    def setNewCycleValues(self):
        self.deltaAtt=0
        #self.attention=random.randint(0,5)
        #self.attention=0


    # attention (total value until previous step)
    def getAttention(self):
        return self.attention
        
    # attention (with the last step)
    def getAttentionAndCleanStep(self):
        self.attention+=self.tickAttention
        self.tickAttention=0
        self.nMethodsAttention=0
        return self.attention

    # ",**d" in the parameter lists of the methods is a place holder
    # in case we use, calling the method, a dictionary as last param.

    # active methods


    # COMPORTAMENTO MOTORIO
    # sitting down not well
    def sitDownNotWell(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm sitting down not well"

        # not relevant for attention

        self.xPos=self.xPos0+random.random()*20-10
        self.setx(self.xPos)
        self.yPos=self.yPos0+random.random()*20-10
        self.sety(self.yPos)

    # sitting down well
    def sitDownWell(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm sitting down well"

        # not relevant for attention

        self.xPos=self.xPos0
        self.setx(self.xPos)
        self.yPos=self.yPos0
        self.sety(self.yPos)

    # standing up
    def standUp(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm standing up"

        # not relevant for attention

        self.xPos=self.xPos0
        self.setx(self.xPos)
        self.yPos=self.yPos0
        self.sety(self.yPos+15)

    # turning back
    def turnBack(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm turning back"

        # not relevant for attention FUTURI EFFETTI SU RISPETTO REGOLE

        self.xPos=self.xPos0+random.random()*30-10
        self.setx(self.xPos)
        self.yPos=self.yPos0+random.random()*30-10
        self.sety(self.yPos)

        
    
    # SPOSTAMENTO NELLO SPAZIO
    # move to blackboard
    def moveToBlackboard(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "going to blackboard"

        # not relevant for attention

        self.xPos=40+random.random()*10-5
        self.setx(self.xPos)
        self.yPos=-125+random.random()*10-5
        self.sety(self.yPos)

    # move to teacher desk
    def moveToTeacherDesk(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "going to teacher desk"

        # not relevant for attention

        self.xPos=200+random.random()*10-5
        self.setx(self.xPos)
        self.yPos=-75+random.random()*10-5
        self.sety(self.yPos)

     # random Movement
     # OLD - the action, also jumping
    def randomMovement(self,**k):
        if random.random()<=self.myWorldState.getGeneralMovingProb():
            print "%s agent # %d moving" % (self.agType,self.number)
            #self.jump=k["jump"]
            self.jump=50
            dx=randomMove(self.jump)
            self.xPos +=dx
            dy=randomMove(self.jump)
            self.yPos += dy
            #self.xPos = (self.xPos + self.worldXSize) % self.worldXSize
            #self.yPos = (self.yPos + self.worldYSize) % self.worldYSize
            if self.xPos < self.lX : self.xPos=self.lX
            if self.xPos > self.rX : self.xPos=self.rX
            if self.yPos < self.lY : self.yPos=self.lY
            if self.yPos > self.rY : self.yPos=self.rY

         # not relevant for attention

            # modify actionGroup "move"
            actionGroup=actionDictionary.get("move","none")
                                    # in case, return "none"
        
            if actionGroup=="none": print "warning, actionGroup not found "+\
                                "in agent "+ str(self.number)
            
            else:
                    actionGroup.setLocalCode(actionGroup.getLocalCode()+\
                                "print 'agent %s # %d made a big jump';" \
                                             % (self.agType,self.number))
                    self.write("I jumped",font=("Arial", 14)) # acting as a turtle

        # tutle reports
        #self.clear()
        self.setx(self.xPos*1)
        self.sety(self.yPos*1)
  

    # AUTOSTIMOLAZIONI FISICHE
    # fidgeting
    def fidget(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm fidgeting"
        add=random.random()*0.2+0.7
        self.nMethodsAttention+=1
        self.tickAttention = (self.tickAttention*(self.nMethodsAttention-1) \
                             + add)                                         \
                             / self.nMethodsAttention
        
        self.write("Fidget", font=("Arial", 12)) # turtle action

        
    # shaking
    def shake(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm shaking"
        if self.agType == "verdePupil":
            add=random.random()*0.2+0.5
        else: add=random.random()*0.2+0.4
        self.nMethodsAttention+=1
        self.tickAttention = (self.tickAttention*(self.nMethodsAttention-1) \
                             + add)                                 \
                             / self.nMethodsAttention

        self.xPos+=random.random()*20-10
        self.setx(self.xPos)
        self.yPos+=random.random()*20-10
        self.sety(self.yPos)

        self.write("Shake", font=("Arial", 14)) # turtle action
        
    # twisting
    def twist(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm twisting"
        add=random.random()*0.3
        self.nMethodsAttention+=1
        self.tickAttention = (self.tickAttention*(self.nMethodsAttention-1) \
                             + add)                                 \
                             / self.nMethodsAttention

        self.xPos+=random.random()*30-10
        self.setx(self.xPos)
        self.yPos+=random.random()*30-10
        self.sety(self.yPos)

        self.write("Twist", font=("Arial", 16)) # turtle action



    # AUTOSIMOLAZIONI VERBALI 
    # mumbling
    def mumble(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm mumbling"

        # not relevant for attention

        self.write("Mumble", font=("Arial", 14)) # turtle action


    # growling
    def growl(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm growling"
        if self.agType == "verdePupil":
            add=random.random()*0.2+0.5
        else: add=random.random()*0.2+0.4
        self.nMethodsAttention+=1
        self.tickAttention = (self.tickAttention*(self.nMethodsAttention-1) \
                             + add)                                 \
                             / self.nMethodsAttention

        self.write("Growl", font=("Arial", 14)) # turtle action


    # COMPORTAMENTO ANTISOCIALE
    # teasing
    def tease(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm teasing"

        # not relevant for attention

        self.write("ihihih", font=("Arial", 14)) # turtle action
        

    # COMPORTAMENTO PROSOCIALE
    # helping classmate
    def helpClassmate(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm helping you"

        # not relevant for attention

        self.write("SOS", font=("Arial", 14)) # turtle action


    # ORIENTAMENTO ATTENZIONE
    # attention elsewhere
    def attElsewhere(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm distracted"
        add=random.random()*0.3
        self.nMethodsAttention+=1
        self.tickAttention = (self.tickAttention*(self.nMethodsAttention-1) \
                             + add)                                 \
                             / self.nMethodsAttention

        self.write("!?!?", font=("Arial", 14)) # turtle action
        
   # attracting attention teacher well
    def attractTeacherAttentionWell(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm attracting Teacher attention well"

        # not relevant for attention

        self.write("Excuse me", font=("Arial", 12)) # turtle action


   # attracting attention teacher not well
    def attractTeacherAttentionNotWell(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm attracting Teacher attention not well"

        # not relevant for attention

        self.write("TEACHER!!", font=("Arial", 14)) # turtle action

        
    # paying attention
    def payAttention(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm paying attention"
        add=1
        self.nMethodsAttention+=1
        self.tickAttention = (self.tickAttention*(self.nMethodsAttention-1) \
                             + add)                                 \
                             / self.nMethodsAttention

    # CONDISCENDENZA
    # doing desk
    def doDesk(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm doing desk"

        # not relevant for attention

        self.write("Do desk", font=("Arial", 14)) # turtle action

    # doing work
    def doWork(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm doing work"

        # not relevant for attention

        self.write("Work", font=("Arial", 14)) # turtle action

    # doing metacognition
    def metaCognition(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm doing metacognition!"
        add=1.0
        self.nMethodsAttention+=1
        self.tickAttention = (self.tickAttention*(self.nMethodsAttention-1) \
                             + add)                                         \
                             / self.nMethodsAttention

        self.write("meta", font=("Arial", 14)) # turtle action


    # COMPORTAMENTO VERBALE
    # talking
    def talk(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm talking"
        add=random.random()*0
        self.nMethodsAttention+=1
        self.tickAttention = (self.tickAttention*(self.nMethodsAttention-1) \
                             + add)                                 \
                             / self.nMethodsAttention

        self.write("bla bla", font=("Arial", 14)) # turtle action


    # talking closely
    def talkClose(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm talking closely"
        if self.agType == "verdePupil":
            add=random.random()*0.2+0.4
        else: add=random.random()*0.2+0.3
        self.nMethodsAttention+=1
        self.tickAttention = (self.tickAttention*(self.nMethodsAttention-1) \
                             + add)                                 \
                             / self.nMethodsAttention

        self.write("ps ps", font=("Arial", 12)) # turtle action

     # checking Teacher and Talking closely
    def checkTeacherTalkClose(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm checking teacher and talking closely"
        if self.agType == "verdePupil":
            add=random.random()*0.2+0.4
        else: add=random.random()*0.2+0.3
        self.nMethodsAttention+=1
        self.tickAttention = (self.tickAttention*(self.nMethodsAttention-1) \
                             + add)                                 \
                             / self.nMethodsAttention

        self.write("spy, ps ps", font=("Arial", 12)) # turtle action


    # talking to teacher well
    def talkTeacherWell(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm talking to the teacher well"
        add=1
        self.nMethodsAttention+=1
        self.tickAttention = (self.tickAttention*(self.nMethodsAttention-1) \
                             + add)                                 \
                             / self.nMethodsAttention

        self.write("ok", font=("Arial", 14)) # turtle action

    # talking to teacher bad
    def talkTeacherBad(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm talking to the teacher bad"
        add=1
        self.nMethodsAttention+=1
        self.tickAttention = (self.tickAttention*(self.nMethodsAttention-1) \
                             + add)                                 \
                             / self.nMethodsAttention

        self.write("gulp", font=("Arial", 14)) # turtle action

    # talking to teacher not well
    def talkTeacherNotWell(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm talking to the teacher not well"
        add=random.random()*0
        self.nMethodsAttention+=1
        self.tickAttention = (self.tickAttention*(self.nMethodsAttention-1) \
                             + add)                                 \
                             / self.nMethodsAttention

        self.write("not ok", font=("Arial", 14)) # turtle action

    # talking to teacher wrong
    def talkTeacherWrong(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm talking to the teacher wrong"
        add=1
        self.nMethodsAttention+=1
        self.tickAttention = (self.tickAttention*(self.nMethodsAttention-1) \
                             + add)                                 \
                             / self.nMethodsAttention

        self.write("bleah", font=("Arial", 14)) # turtle action
        

    # asking well
    def askWell(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm asking well!"
        add=1.0
        self.nMethodsAttention+=1
        self.tickAttention = (self.tickAttention*(self.nMethodsAttention-1) \
                             + add)                                         \
                             / self.nMethodsAttention

        self.write("Ask ok", font=("Arial", 14)) # turtle action

    # asking desk
    def askRepeat(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm asking repeat"

        # not relevant for attention

        self.write("Repeat", font=("Arial", 14)) # turtle action



    # answering Chorus (PROVVISORIO)
    def answerChorus(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm answering chorus"
        add=random.random()*0
        self.nMethodsAttention+=1
        self.tickAttention = (self.tickAttention*(self.nMethodsAttention-1) \
                             + add)                                 \
                             / self.nMethodsAttention

        self.write("Chorus", font=("Arial", 14)) # turtle action

        
    # answering (well)
    def answerWell(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "answering well"
        add=1
        self.nMethodsAttention+=1
        self.tickAttention = (self.tickAttention*(self.nMethodsAttention-1) \
                             + add)                                 \
                             / self.nMethodsAttention

        self.write("answ ok", font=("Arial", 14)) # turtle answ

    # answering (bad)
    def answerBad(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "answering bad"
        add=1
        self.nMethodsAttention+=1
        self.tickAttention = (self.tickAttention*(self.nMethodsAttention-1) \
                             + add)                                 \
                             / self.nMethodsAttention

        self.write("answ gulp", font=("Arial", 14)) # turtle answ

    # answering (not well)
    def answerNotWell(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "answering not well"
        add=random.random()*0
        self.nMethodsAttention+=1
        self.tickAttention = (self.tickAttention*(self.nMethodsAttention-1) \
                             + add)                                 \
                             / self.nMethodsAttention

        self.write("answ not ok", font=("Arial", 14)) # turtle answ

    # answering (wrong)
    def answerWrong(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "answering wrong"
        add=1
        self.nMethodsAttention+=1
        self.tickAttention = (self.tickAttention*(self.nMethodsAttention-1) \
                             + add)                                 \
                             / self.nMethodsAttention

        self.write("answ bleah", font=("Arial", 14)) # turtle answ

    # AZIONI STATO BANCO PROPRIO
    # tidying
    def tidy(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm tidying"
        add=random.random()*0.2+0.7
        self.nMethodsAttention+=1
        self.tickAttention = (self.tickAttention*(self.nMethodsAttention-1) \
                             + add)                                         \
                             / self.nMethodsAttention
    
    
        self.write("Tidy", font=("Arial", 12)) # turtle action


    # untidying
    def untidy(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm untidying"
        add=random.random()*0.2+0.7
        self.nMethodsAttention+=1
        self.tickAttention = (self.tickAttention*(self.nMethodsAttention-1) \
                             + add)                                         \
                             / self.nMethodsAttention
    
    
        self.write("Untidy", font=("Arial", 12)) # turtle action


    # untidying-tidying
    def untidyTidy(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm untidying tidying"
        add=random.random()*0.2+0.6
        self.nMethodsAttention+=1
        self.tickAttention = (self.tickAttention*(self.nMethodsAttention-1) \
                             + add)                                         \
                             / self.nMethodsAttention
    
    
        self.write("un-tidy", font=("Arial", 12)) # turtle action

    # AZIONI STATO BANCO ALTRUI
    # borrowing
    def borrow(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm borrowing"
        add=random.random()*0.2+0.7
        self.nMethodsAttention+=1
        self.tickAttention = (self.tickAttention*(self.nMethodsAttention-1) \
                             + add)                                         \
                             / self.nMethodsAttention
    
    
        self.write("Borrow", font=("Arial", 12)) # turtle action


    # AZIONI STATO FISICO PERSONALE
    # wellness
    def wellness(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "Wellness"
        add=random.random()*0.2+0.7
        self.nMethodsAttention+=1
        self.tickAttention = (self.tickAttention*(self.nMethodsAttention-1) \
                             + add)                                 \
                             / self.nMethodsAttention

        self.xPos+=random.random()*20-10
        self.setx(self.xPos)
        self.yPos+=random.random()*20-10
        self.sety(self.yPos)

        self.write("wellness", font=("Arial", 14)) # turtle action


    # MANIFESTAZIONE STATI EMOTIVI


    # being praised
    def bePraised(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm being praised"

        # not relevant for attention

        self.write("Good", font=("Arial", 14)) # turtle action


    # be quite bored
    def beQuiteBored(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm quite bored"
        add=random.random()*0.2+0.6
        self.nMethodsAttention+=1
        self.tickAttention = (self.tickAttention*(self.nMethodsAttention-1) \
                             + add)                                         \
                             / self.nMethodsAttention
    
    
        self.write("uffa", font=("Arial", 12)) # turtle action

    # being scolded
    def beScolded(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm being scolded"

        # not relevant for attention

        self.write("ohi ohi", font=("Arial", 14)) # turtle action

    # be very bored
    def beVeryBored(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm very bored"
        add=random.random()*0.2+0.3
        self.nMethodsAttention+=1
        self.tickAttention = (self.tickAttention*(self.nMethodsAttention-1) \
                             + add)                                         \
                             / self.nMethodsAttention
    
    
        self.write("ronf", font=("Arial", 12)) # turtle action






    # CONTROLLO STATI
    # checking teacher
    def checkTeacher(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm checking teacher"

        # not relevant for attention

        self.write("spy teacher", font=("Arial", 14)) # turtle action



    # checking classmate work
    def checkClassmateWork(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm checking classmate work"

        # not relevant for attention

        self.write("spy work", font=("Arial", 14)) # turtle action
        


    # checking work
    def checkWork(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm checking work"

        # not relevant for attention

        self.write("check work", font=("Arial", 14)) # turtle action


    # checking fast work
    def checkFastWork(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm checking fast work"

        # not relevant for attention

        self.write("check fast work", font=("Arial", 14)) # turtle action


    # checking learning
    def checkLearning(self,**d):
        print "I'm %s agent %d: " % (self.agType,self.number),
        print "I'm checking learning"

        # not relevant for attention

        self.write("Do I Know?", font=("Arial", 14)) # turtle action





    # OLDS


    # report
    def reportPosition(self,**d):
        print self.agType, "#", self.number, "is at X =", \
               self.xPos, " Y =", self.yPos

    def getAgType(self):
        return self.agType

    # methods for Tk graphic applications
    def getXPos(self):
        return self.xPos

    def getYPos(self):
        return self.yPos

    def setGraphicItem(self, grI):
        self.graphicItem=grI

    def getGraphicItem(self):
        return self.graphicItem

# returns -1, 0, 1  with equal probability
def randomMove(jump):
    return random.randint(-1, 1)*jump
